/*
 *
 * @(#)SubsetPalette.java 2.0 00/05/16
 *
 * Copyright (c) 2000 Ginger Booth.  All Rights Reserved.
 *
 * @author Ginger Booth
 * @version 2.0, 00/05/16
 *
 * A perturbation selection of some other Palettable. E.g., out of that Palette's
 * entirely, pick 24, ordered as desired, and act like a Palette of size 24.
 */


package com.gingerbooth.websafe;
import courseware.util.*;
import courseware.plot.*;
import courseware.jfcdep.*;
import java.awt.Color;

public class SubsetPalette implements Palettable {
  private Palettable palette;
  private int[] perturb;

  public SubsetPalette(Palettable masterPalette, int[] orderedSelection) {
    palette = masterPalette;
    perturb = orderedSelection;
  }
  /** returns color by master (database) index. */
  public Color getColor(int i) { return palette.getColor(i); }
  public int getNumColors() { return perturb.length; }
  public void setColor(int i, Color c) { palette.setColor(i, c);}

  /** returns color by subset member index--goes with getNumColors */
  public Color getOrderedColor(int i) {return palette.getColor(perturb[i]);}
  public int getOrderedID(int i) {return perturb[i];}
  /** find what perturbed order number a master palette color is */
  public int getOrder(int masterID) {
    int answer = -1;
    for (int i=0; i<perturb.length; i++) {
      if (perturb[i] == masterID)
        answer = i;
    }
    return answer;
  }
}
