/*
 *
 * @(#)IndexParam.java 0.2 98/07/08
 *
 * Copyright (c) 1998 Ginger Booth.  All Rights Reserved.
 *
 * @history: 980708, original, want easy way to put indexed
 *           parameters onto menu (type setList(i, value)).
 * @author Ginger Booth
 * @version 0.2, July 1998
 */

/** I'm not thinking of any better name for this class, since it
 *  accurately reflects what I want it for, and what it's used for
 *  maybe every time. But an IndexParam displays an editable value
 *  on a popup for the second, rather than only, argument. It's
 *  useful for parameters of the form setListValue(which, value)
 *  when you want to put it on a popup--edit the value, hide the which.
 */

package courseware.util;
import java.util.*;
import java.lang.reflect.*;

public class IndexParam extends Param {

    // nuisance, these do nothing but call super.

    public IndexParam(String label, Object[] val, Class oclass, Method classMethod,
                 boolean display)
    {  super(label, val, oclass, classMethod, display); }

    public IndexParam(String label, Object val, Class oclass, Method classMethod,
                 boolean display)
    { super(label, val, oclass, classMethod, display); }

    public IndexParam(String label, Object[] val, Object atarget,
                 Method classMethod, boolean display)
    { super(label, val, atarget, classMethod, display); }

    public IndexParam() { super(); }

    public void setIndex(int i) {value[0] = new Integer(i); }

    public int getIndex() { Integer i = (Integer) value[0]; return i.intValue(); }

    public void setValue(Object newValue) { value[1] = newValue; }

    public Object getValue() { return value[1];}

    public Vector components() {
    return components(1); }

    /** Set 2nd value from the Vector of components.  */
    public void readComponents(Vector widgets, int startcolumn) {
      readComponents(1, widgets, startcolumn);
    }

    public String toString()
    {
        return "IndexParam[name=" + name +
            ",value=(" + valueString() +
            "),owner=" + owner +
            ",method=" + method +
            ",displayable=" + displayable +
            "]";
    }
}
