//Title:        Gecko
//Version:
//Copyright:    Copyright (c) 1999, All rights reserved
//Author:       Ginger Booth, gingerbooth@cyber-wizard.com, ginger@gbooth.com
//Company:      Yale IBS/CCE
//Description:  Individual-Based Ecology Simulator

/** Stats (mostly via superclass StatMinder) glues Gecko Species onto
 *  stats package machinery. Supercedes Indeco's MetaPlotBuilder.
 */

package gecko;

import stats.*;
public class Stats extends StatMinder {

  public Stats(UI ui) { super(ui);}

  /** This adds a metaplot to metaPlots, but does NOT put it
   *  on the UI.
   */
  synchronized public MetaPlot getMetaPlot(String title) {
    MetaPlot mp = super.getMetaPlot(title);
    if (mp==null) {
      mp = new MetaPlot(title, getUI());
      addMetaPlot(mp);
    }
    return mp;
  }

}