#include "colors.inc"
#include "textures.inc" 
#include "finish.inc"
#include "glass.inc"
#include "skies.inc"

#macro WorldSize(xmin, ymin, xmax, ymax) 
camera {  
  location <5, 17, -15>
  look_at<(xmax-xmin)/2, 0, (ymax-ymin)/2 - 5>
}
light_source {
    <xmax/2, 50, -25>
    color White
  }       
#end  

plane { y, 0
   pigment { color rgb <1, 1, .9> }
   finish {
      ambient 0.7
      diffuse 0.5
   }
}            

#declare P_Cloud1 =
pigment {
    bozo
    turbulence 0.65
    octaves 6
    omega 0.7
    lambda 2 
    color_map {
        [0.0, 0.1   color red 0.85 green 0.85 blue 0.85
                    color red 0.75 green 0.75 blue 0.75]
        [0.1, 0.5   color red 0.75 green 0.75 blue 0.75
                    color Clear]
        [0.5, 1.001 color Clear
                    color Clear]
    }
    scale <6, 1, 6>  
}
 
#declare T_BrightCloud1 =
texture {                              // The upper part of the clouds
    pigment {
        P_Cloud1
    }
    finish {
        ambient 1.0
        diffuse .4
    }
}
texture {                              // The darker underside of the clouds
    pigment {
        P_Cloud1  
        translate -0.15*y
    }
    finish {
        ambient 0.8
        diffuse 0
    }
} 

#macro TimePicture(atTime)  
sphere { <0,0,0>, 100   
    pigment { colour rgb <.3,.6,1> }
    texture {
        T_BrightCloud1
        scale 10
// factor on atTime is compromise between moving enuf to be visible
// on one step, yet provide continuity when step for 30--shrug.
        translate <-atTime*.17, 0, 0> 
    }  
}
#end         

#macro Nitro ( cx, cy, cheight, gradius )
sphere { <cx,cheight,cy> gradius
  material {
    texture { 
      finish { F_Glass3 }
      pigment { color rgbf <1, 1, 0, 0.8> }
    }
    interior {I_Glass}
  }
}
#end           

#macro Nitroso ( cx, cy, cheight, sradius )
sphere { <cx,cheight,cy> sradius
  material {
    texture {
      finish { F_Glass3 }
      pigment { color rgbf <.7, 0, .1, 0.9> }
    }
    interior {I_Glass}
  }
}
#end      
