//Title:        Gecko
//Version:
//Copyright:    Copyright (c) 1999, All rights reserved
//Author:       Ginger Booth, gingerbooth@cyber-wizard.com, ginger@gbooth.com
//Company:      Yale IBS/CCE
//Description:  Individual-Based Ecology Simulator
/** Feeds through biomassTax tallies to a plot/file trace.
 *  Biomass taxes are collected by LandRoot, and served to
 *  the stats machinery via the Site. In grassworld, all metabolic
 *  taxes are paid by critters in resource getIam(). Death also
 *  pays all-that's-left-of-me as taxes. Hence, nobody pays taxes
 *  in sunwater, plants pay carbos, etc. And all seeds that fell on
 *  fallow ground are included in biomassTax(carbos).
 */

package gecko.statglue;

import stats.*;
import gecko.*;

public class BiomassTaxBroker extends StatSourceBroker {
  private double scale;
  private int resourceId;

  /** If in doubt, set scaleFactor = 1.0. */
  public BiomassTaxBroker(Site s, int resourceId) {
    statsource = (StatSource) s;
    this.resourceId = resourceId;
    scale      = Globals.getResources().getBioScale(resourceId);
  }
  public double getValue() {
    return ((Site) statsource).getBiomassTax(resourceId);
  }
  public double getWeight() { return scale; };
}

