
//Title:        Indeco Steel Simulator
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Joseph Guse & Ginger Booth
//Company:      Yale FES/CCE
//Description:  Individual-based economic simulator
//of the steel industry, ore->consumer,
//with transportation.

/** Trace single statistic. Just simplified interface to SumTrace. The
 *  statistic is normalized, but not weighted. (getValue & getNormalizer
 *  called, but not getWeight.) An xbegin of zero is assumed, but you can
 *  use statTrace.setBegin(int) to correct that.
 */

/** Adopted from Indeco for Gecko-in-CourseWare, 990708, vfb. */

package stats;

import java.awt.Color;

public class StatTrace extends SumTrace {

  public StatTrace(String label, StatBrokerable broker) {
    setLabel(label);
    addY(broker);
    start();
  }
  public StatTrace(String label, Color color, Timer timer,
    StatBrokerable broker, StatDumper target)
  {
    this(label, broker);
    setColor(color);
    setXTime(timer);
    target.addTrace(this);
  }

  public double doSum() {
    StatBrokerable broker = (StatBrokerable) members.elementAt(0);
    return broker.getValue() * broker.getNormalizer();
  }
}