//Title:        Gecko
//Version:
//Copyright:    Copyright (c) 1999, All rights reserved
//Author:       Ginger Booth, gingerbooth@cyber-wizard.com, ginger@gbooth.com
//Company:      Yale IBS/CCE
//Description:  Individual-Based Ecology Simulator

package stats;

public class TimeBroker implements StatBrokerable {
  private Timer timer;
  public TimeBroker(Timer t) {
    timer = t;
  }
  /** Who does this broker get stats from? */
  public Object getStatSource() { return timer; }
  /** getValue() always returns normalized, unweighted value. */
  public double getValue() {return (double) timer.getCurrentTime();}
  /** getWeight()'s values are never normalized. */
  public double getWeight() { return 1.0;}

  /** normalizer should always default to 1.0 until told otherwise.
   *  Unlike weight and value, which may well vary from simulation
   *  step to step, a normalizer is a constant.  Hence, it's the only
   *  field for which a "set" is really possible. (The last thing we
   *  want is the Agent changing in midstream...)
   */
  public double getNormalizer() { return 1.0; }
  public void setStatSource(Object o) { timer = (Timer) o;}
  public void setNormalizer(double d) { }
}